#!/usr/bin/perl
$PageLength=10;
&ReadStyle;
$FormData=$ENV{QUERY_STRING};
exit(&MakeHtml);

###
sub MakeHtml{
	my(@bbs,$index,$html,$content,$menu,$i,@temp);
	$index=&GetValue($FormData,"INDEX");
	open(FILE,"bbs.data");
	@bbs=<FILE>;
	close(FILE);
	for($i=$index*$PageLength;$i<($index+1)*$PageLength && $bbs[$i];$i++){
		@temp=split(/</,$bbs[$i]);
		$content.=&InsertString($Style{"line"},&ContentEncode($temp[0]),&NameEncode($temp[1]),&TimeEncode($temp[2]));
	}
	if($index>0){
		$menu.="<a href='read.cgi?INDEX=${\($index-1)}'>&lt;&lt;</a>";
	}else{
		$menu.="&lt;&lt;";
	}
	$menu.=" ".($index+1)." ";
	if($bbs[($index+1)*$PageLength]){
		$menu.="<a href='read.cgi?INDEX=${\($index+1)}'>&gt;&gt;</a>";
	}else{
		$menu.="&gt;&gt;";
	}
	$html=&InsertString($Style{"base"},$content,$menu);
	&OutHtml($html);
	return;
}
###
sub TimeEncode{
	my(@time);
	@time=localtime(shift);
	$time[4]++;
	$time[4]="0".$time[4] if(length($time[4])==1);
	$time[3]="0".$time[3] if(length($time[3])==1);
	$time[2]="0".$time[2] if(length($time[2])==1);
	$time[1]="0".$time[1] if(length($time[1])==1);
	return("$time[4]/$time[3] $time[2]:$time[1]");
}
###
sub NameEncode{
	my($str);
	$str=shift;
	$str=&UrlUnescape($str);
	$str=&MetaEscape($str);
	$str=~s/\r//g;
	$str=~s/\n//g;
	$str="No name" if(!$str);
	return($str);
}
###
sub ContentEncode{
	my($str);
	$str=shift;
	$str=&UrlUnescape($str);
	$str=&MetaEscape($str);
	$str=~s/(http:\/\/[\w\!\#\$\%\&\'\(\)\=\-\~\^\|\\\@\{\[\+\;\*\:\}\],\.\/\?\_]+)/&AutoLink($1)/eg;
	$str=~s/\r//g;
	$str=~s/\n/<br>/g;
	return($str);
}
###
sub AutoLink{
	my($href,$text);
	$href=shift;
	$text=$href;
	$href=~s/&amp;/&/g;
	return("<a href='$href' target='_blank'>$text<\/a>");
}
###
sub MetaEscape{
	my($str);
	$str=shift;
	$str=~s/&/&amp;/g;
	$str=~s/</&lt;/g;
	$str=~s/>/&gt;/g;
	$str=~s/ /&nbsp;/g;
	return($str);
}
###
sub ReadStyle{
	my(@dir);
	opendir(DIR,"style");
	@dir=readdir(DIR);
	closedir(DIR);
	foreach(@dir){
		if(/^(\w+)\.data$/){
			$Style{$1}="";
			open(FILE,"style/$1.data");
			while(<FILE>){
				$Style{$1}.=$_;
			}
			close(FILE);
		}
	}
	return;
}
###
sub InsertString{
	my($result);
	$result=$_[0];
	$result=~s/\$SCRIPT\((\d+)\)/$_[$1]/g;
	return($result);
}
###
sub UrlUnescape{
	my($str);
	$str=$_[0];
	$str=~tr/+/ /;
	$str=~s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2",$1)/eg;
	return($str);
}
###
sub GetValue{
	my(@objects);
	@objects=split(/[&]/,$_[0]);
	foreach(@objects){
		return($1) if(/^$_[1]=(.+)$/);
	}
	return;
}
###
sub OutHtml{
	print "content-type:text/html\n\n";
	print $_[0];
	return;
}
###
